#!/usr/bin/perl
######################################################################
# RSSCGI Ver 1.0.2
# iǗj[pXNvgj
# Copyright(C) futomi 2005
# http://www.futomi.com/
######################################################################
use strict;
BEGIN {
	use FindBin qw($Bin);
	use lib './lib', "$FindBin::Bin/lib";
	use CGI;
	use CGI::Carp qw(fatalsToBrowser);
	use FCC::Apache::Session;
	use Digest::Perl::MD5;
	use MIME::Base64::Perl;
	use Jcode;
	use Time::Local;
	use HTML::Template;
	if($ENV{'SERVER_SOFTWARE'} =~ /IIS/i){
		chdir $FindBin::Bin;
	}
}
my $q = new CGI;
$| = 1;

my $VERSION = '1.0.2';
#Copyright
my $COPYRIGHT = "futomi's CGI Caf&#233; - RSSCGI $VERSION";
my $COPYRIGHT1 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">futomi\'s CGI Caf&#233;</a>";
my $COPYRIGHT2 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">${COPYRIGHT}</a>";

#CGIt@C̃t@C擾
my $CGI_URL = &GetThisFileName;

#Cookie
my $COOKIE_NAME = 'session';

#ݒf[^擾
my %CONF = &GetConf('./conf/config.cgi');
my %CONF2 = &GetConf('./conf/channel.cgi');
my %CONF3 = &GetConf('./conf/ping.cgi');

#Lf[^i[fBNg̒`
$CONF{'DATA_DIR'} = './data';

#e̎擾
my $action = $q->param('a');

#Ǘ҃pX[ho^
if($action eq 'pass_new') {
	&PasswdChange;
}
#ǗID/PWo^ĂȂ΁Aݒʂ\
if($CONF{'ADMIN_ID'} eq '' || $CONF{'PASS'} eq '') {
	&PrintPasswdSetForm;
}

#F
my %cookies = &GetCookie;
my $sid = $cookies{$COOKIE_NAME};
my %session_data;
my $session;
if($action eq 'logon') {
	&LogOn;
} elsif($sid) {
	&SessionAuth($sid, \%session_data);
} else {
	&PrintLogonForm;
}

#
if($action eq '') {
	&PrintParentFrame
} elsif($action eq 'menu') {
	&PrintMenuFrame;
} elsif($action eq 'top') {
	&PrintTopFrame;
} elsif($action eq 'conf1') {
	&PrintConf1Form;
} elsif($action eq 'setconf1') {
	&SetConf1;
	&PrintComplete(
		"ݒ肪܂B",
		"VXeݒʂɖ߂",
		"${CGI_URL}?a=conf1"
	);
} elsif($action eq 'conf2') {
	&PrintConf2Form;
} elsif($action eq 'setconf2') {
	&SetConf2;
	&PrintComplete(
		"ݒ肪܂B",
		"`lݒʂɖ߂",
		"${CGI_URL}?a=conf2"
	);
} elsif($action eq 'conf3') {
	&PrintConf3Form;
} elsif($action eq 'setconf3') {
	&SetConf3;
	&PrintComplete(
		"ݒ肪܂B",
		"XVpingݒʂɖ߂",
		"${CGI_URL}?a=conf3"
	);
} elsif($action eq 'itemaddform') {
	&PrintItemAddForm;
} elsif($action eq 'itemaddconfirm') {
	&PrintItemAddConfirm;
} elsif($action eq 'itemadd') {
	#DBɋLL^
	&ItemAddToDb;
	#ߋL폜
	&DeletePastItems;
	#RSSXV
	&UpdateRss;
	#pingMJn
	if($CONF3{'PING_FLAG'} ne '1') {
		my @ping_servers = $q->param('PING_SERVERS');
		my $num = scalar @ping_servers;
		if($num) {
			&PingSendInit($sid, \@ping_servers);
			&PingSendProgress($sid);
		}
	}
	#ʕ\
	&PrintComplete(
		"VKLo^܂B",
		"Lꗗ",
		"${CGI_URL}?a=itemlist"
	);
} elsif($action eq 'itemlist') {
	&PrintItemList;
} elsif($action eq 'itemmodform') {
	&PrintItemModForm;
} elsif($action eq 'itemmodconfirm') {
	&PrintItemModConfirm;
} elsif($action eq 'itemmod') {
	my @items = $q->param('itemid');
	#DBYL폜
	&ItemDelCheck(\@items);
	&ItemDel(\@items);
	#VKLƂDBɏ
	&ItemAddToDb;
	#RSSXV
	&UpdateRss;
	#pingMJn
	if($CONF3{'PING_FLAG'} ne '1' && $CONF3{'PING_TIMING'} eq '2') {
		my @ping_servers = $q->param('PING_SERVERS');
		my $num = scalar @ping_servers;
		if($num) {
			&PingSendInit($sid, \@ping_servers);
			&PingSendProgress($sid);
		}
	}
	#ʕ\
	&PrintComplete(
		"LXV܂B",
		"Lꗗɖ߂",
		"${CGI_URL}?a=itemlist"
	);
} elsif($action eq 'itemdel') {
	my @del_items = $q->param('itemid');
	#폜`FbN
	unless($q->param('DELFLAG')) {
		&ErrorPrint("L폜ꍇɂ́Au{ɍ폜vɃ`FbNĉB");
	}
	&ItemDelCheck(\@del_items);
	#DBL폜
	&ItemDel(\@del_items);
	#RSSXV
	&UpdateRss;
	#ʕ\
	&PrintComplete(
		"L폜܂B",
		"Lꗗɖ߂",
		"${CGI_URL}?a=itemlist"
	);
} elsif($action eq 'rebuildform') {
	&PrintRebuildForm;
} elsif($action eq 'rebuild') {
	&UpdateRss;
	#ʕ\
	&PrintComplete(
		"č\\z܂B",
		"gbvɖ߂",
		"${CGI_URL}?a=top"
	);
} elsif($action eq 'passwd_change_form') {
	&PrintPasswdForm;
} elsif($action eq 'passwd_change') {
	&PasswdChange;
	&PrintPasswdChangeComplete;
} elsif($action eq 'ping') {
	&PingSendProgress($sid);
} elsif($action eq 'updatetempform') {
	&PrintUpdateTempForm;
} elsif($action eq 'updatetemp') {
	&UpdateTemp;
	#RSSXV
	&UpdateRss;
	#ʕ\
	&PrintComplete(
		"XV܂B",
		"gbvɖ߂",
		"${CGI_URL}?a=top"
	);
} elsif($action eq 'viewrss') {
	&PrintViewRss;
} elsif($action eq 'viewrss_b') {
	&PrintRssToBrowser;
} elsif($action eq 'help') {
	&PrintHelp;
} elsif($action eq 'logoff') {
	&LogOff($sid);
} else {
	&ErrorPrint("sȃANZXłB");
}

exit;


##### Tu[` ###################################################

sub PrintRssToBrowser {
	my $type = $q->param('type');
	my $file;
	if($type eq 'rss10') {
		$file = $CONF{'FILE_PATH_RSS10'};
	} elsif($type eq 'rss20') {
		$file = $CONF{'FILE_PATH_RSS20'};
	} elsif($type eq 'html') {
		$file = $CONF{'HTML_PATH'};
	}
	#t@Cǂݎ
	my $data = &ReadTextFile($file);
	#HTML̏ꍇɂ́ACharset`
	my $content_type;
	if($type eq 'rss10') {
		$content_type = "application/xml; charset=utf-8";
	} elsif($type eq 'rss20') {
		$content_type = "text/xml; charset=utf-8";
	} elsif($type eq 'html') {
		my $charset;
		if($CONF{'HTML_CHARSET'} eq '1') {
			$charset = 'Shift_JIS';
		} elsif($CONF{'HTML_CHARSET'} eq '2') {
			$charset = 'EUC-JP';
		} elsif($CONF{'HTML_CHARSET'} eq '3') {
			$charset = 'utf-8';
		}
		$content_type = "text/html; charset=${charset}";
	}
	#ʏo
	my $content_length = length $data;
	print "Content-Type: ${content_type}\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $data;
	exit;
}

sub PrintViewRss {
	my($file, $comment, $type);
	if($q->param('rss10')) {
		$file = $CONF{'FILE_PATH_RSS10'};
		$comment = "RSS1.0tH[}bg : ${file}";
		$type = 'rss10';
	} elsif($q->param('rss20')) {
		$file = $CONF{'FILE_PATH_RSS20'};
		$comment = "RSS2.0tH[}bg : ${file}";
		$type = 'rss20';
	} elsif($q->param('html')) {
		$file = $CONF{'HTML_PATH'};
		$comment = "HTMLtH[}bg : ${file}";
		$type = 'html';
	}
	my $data;
	if(-e $file) {
		$data = &ReadTextFile($file);
		&Jcode::convert(\$data, 'sjis');
	}
	$data = &SecureHtml($data);
	#ʃev[gǎ
	my $html = &ReadTemplate("./template/admin/viewrss.html");
	#{^
	my @buttons;
	if($CONF{'FORMAT_RSS10'}) {
		push(@buttons, "<input type=\"submit\" name=\"rss10\" value=\"RSS1.0\">");
	}
	if($CONF{'FORMAT_RSS20'}) {
		push(@buttons, "<input type=\"submit\" name=\"rss20\" value=\"RSS2.0\">");
	}
	if($CONF{'HTML_FLAG'}) {
		push(@buttons, "<input type=\"submit\" name=\"html\" value=\"HTML\">");
	}
	my $button_tag = join("@@", @buttons);
	#uEU[\{^𐶐
	my $browser_view_button;
	if(-e $file) {
		$browser_view_button = "<button name=\"viewBtn\" value=\"1\" type=\"button\" onclick=\"window.open('${CGI_URL}?a=viewrss_b&type=${type}', 'newwin', '')\">${comment} uEU[ŕ\\</button>";
	}
	#uwqu
	$html =~ s/\$data\$/${data}/;
	$html =~ s/\$comment\$/${comment}/;
	$html =~ s/\$buttons\$/${button_tag}/;
	$html =~ s/\$browser_view_button\$/${browser_view_button}/;
	#ʏo
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PingSend {
	my($ping_server, $channel_title, $channel_link) = @_;
	#W[̃[h
	eval {
		require FCC::Net::http;
		require XML::Simple;
	};
	if($@) {
		&ErrorPrint("W[̃[hɎs܂B<br>$@");
	}
	#POSTf[^̍\
	my($header, $res);
	my $content_type = "text/xml";
	my $data = &ReadTemplate('./template/rss/ping.xml');
	$channel_title = &SecureHtml($channel_title);
	$data =~ s/\$CHANNEL_TITLE\$/${channel_title}/g;
	$data =~ s/\$CHANNEL_LINK\$/${channel_link}/g;
	#pingM
	my $res_data = FCC::Net::http::post($ping_server, $content_type, $data, \$header, \$res);
	if($res) {
		return $res;
	}
	#X|Xf[^̉
	my $xml;
	eval {
		my $xml_simple = XML::Simple->new();
		$xml = $xml_simple->XMLin("$res_data");
	};
	if($@) {
		my $err = $@;
		$err = &UnifyReturnCode($err);
		$err =~ s/\n//g;
		return $err;
	}
	if($xml->{'fault'}) {
		my $faultCode = $xml->{'fault'}->{'value'}->{'struct'}->{'member'}->{'faultCode'}->{'value'}->{'int'};
		my $faultString = $xml->{'fault'}->{'value'}->{'struct'}->{'member'}->{'faultString'}->{'value'}->{'string'};
		$faultString = &UnifyReturnCode($faultString);
		$faultString =~ s/\n//g;
		return "$faultCode : $faultString";
	} elsif($xml->{'params'}) {
		my $flerror = $xml->{'params'}->{'param'}->{'value'}->{'struct'}->{'member'}->{'flerror'}->{'value'}->{'boolean'};
		my $message = $xml->{'params'}->{'param'}->{'value'}->{'struct'}->{'member'}->{'message'}->{'value'};
		$message = &UnifyReturnCode($message);
		$message =~ s/\n//g;
		if($flerror) {
			return "${flerror} : ${message}";
		}
	}
	return;
}

sub PingSendProgress {
	my($sid) = @_;
	#pingXg擾
	open(FILE, "./session/${sid}.ping.cgi") or &ErrorPrint("XVpingT[oXg擾Ɏs܂B: $!");
	my %pings;
	while(my $line = <FILE>) {
		chomp $line;
		my($i, $url, $result) = split(/\t/, $line);
		if($i ne '' && $url ne '') {
			$pings{$i} = [$url, $result];
		}
	}
	close(FILE);
	#pingT[oNo擾
	my $ping_no = $q->param('no');
	#pingM
	if(exists $pings{$ping_no}) {
		my $result = &PingSend($pings{$ping_no}->[0], $CONF2{'CHANNEL_TITLE'}, $CONF2{'CHANNEL_LINK'});
		$pings{$ping_no}->[1] = $result;
		$ping_no ++;
	} else {
		$ping_no = 1;
	}
	#pingXgXV
	open(FILE, ">./session/${sid}.ping.cgi") or &ErrorPrint("XVpingT[oXgXVɎs܂B: $!");
	for my $i (keys %pings) {
		my $url = $pings{$i}->[0];
		my $result = $pings{$i}->[1];
		print FILE "${i}\t${url}\t${result}\n";
	}
	close(FILE);
	#o͉ʐ
	my $html;
	if(exists $pings{$ping_no}) {
		#pingM
		$html = &ReadTemplate("./template/admin/ping_progress.html");
		my $msg = "$pings{$ping_no}->[0] ɍXVping𑗐M...";
		$html =~ s/\$progress\$/${msg}/;
		$html =~ s/\$no\$/${ping_no}/g;
	} else {
		#pingM
		unlink "./session/${sid}.ping.cgi";
		$html = &ReadTemplate("./template/admin/ping_complete.html");
		my $msg;
		$msg .= "<table border=\"0\">\n";
		my @tr_list;
		for my $no (sort {$a<=>$b} keys %pings) {
			my $tr;
			$tr .= "<tr>\n";
			$tr .= "<td valign=\"top\">$pings{$no}->[0]</td>\n";
			$tr .= "<td valign=\"top\"> F </td>\n";
			my $result = $pings{$no}->[1];
			if($result) {
				my $result = &SecureHtml($result);
				$tr .= "<td valign=\"top\"><font color=\"red\">${result}</font></td>\n";
			} else {
				$tr .= "<td valign=\"top\"><font color=\"green\">OK</font></td>\n";
			}
			$tr .= "</tr>\n";
			push(@tr_list, $tr);
		}
		my $border = "<tr><td colspan=\"3\" height=\"1\" bgcolor=\"#8C7633\"></td></tr>\n";
		$msg .= join("${border}", @tr_list);
		$msg .= "</table>\n";
		$html =~ s/\$progress\$/${msg}/;
	}
	#ʏo
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PingSendInit {
	my($sid, $servers_ref) = @_;
	my $temp_file = "./session/${sid}.ping.cgi";
	open(FILE, ">${temp_file}") or &ErrorPrint("XVpingMɎs܂B: $!");
	my $i = 1;
	for my $s (@{$servers_ref}) {
		print FILE "${i}\t${s}\n";
		$i ++;
	}
	close(FILE);
}

sub UpdateTemp {
	my $html_template = $q->param('html_template');
	$html_template = &UnifyReturnCode($html_template);
	my $file = "./template/rss/custom.new.html";
	open(FILE, ">${file}") or &ErrorPrint("ev[gXVɎs܂B: $!");
	print FILE $html_template;
	close(FILE);
}

sub PrintUpdateTempForm {
	my $default_flag = $q->param('default');
	my $custom_temp = "./template/rss/custom.new.html";
	my $default_temp = "./template/rss/new.html";
	my $temp_file;
	if($default_flag) {
		$temp_file = $default_temp;
	} elsif(-e $custom_temp) {
		$temp_file = $custom_temp;
	} else {
		$temp_file = $default_temp;
	}
	my $html_template_data = &ReadTemplate("${temp_file}");
	$html_template_data = &SecureHtml($html_template_data);
	my $html = &ReadTemplate("./template/admin/template.html");
	$html =~ s/\$html_template\$/${html_template_data}/;
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintRebuildForm {
	my $html = &ReadTemplate("./template/admin/rebuild.html");
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintItemModConfirm {
	my $itemid = $q->param('itemid');
	if($itemid eq '') {
		&ErrorPrint("Lw肳Ă܂B");
	} elsif($itemid !~ /^\d{12}$/) {
		&ErrorPrint("sȒlM܂B");
	}
	unless(-e "$CONF{'DATA_DIR'}/${itemid}.cgi") {
		&ErrorPrint("w̋L͓o^Ă܂B: itemid=${itemid}");
	}
	#ʃev[gHTMLǂݍ
	my $html = &ReadTemplate("./template/admin/itemmodconfirm.html");
	#͒l`FbN
	my %in = &ItemInputCheck;
	#uwqu/hidden^O
	my @hiddens;
	my $mon = sprintf("%02d", $in{'MON'});
	my $day = sprintf("%02d", $in{'DAY'});
	my $hour = sprintf("%02d", $in{'HOUR'});
	my $min = sprintf("%02d", $in{'MIN'});
	my $sec = sprintf("%02d", $in{'SEC'});
	my $date = "$in{'YEAR'}/${mon}/${day} ${hour}:${min}:${sec}";
	$html =~ s/\$DATE\$/${date}/g;
	my @ping_servers = @{$in{'PING_SERVERS'}};
	my $ping_html = join("<br>\n", @ping_servers);
	$html =~ s/\$PING_SERVERS\$/${ping_html}/;
	for my $p (@ping_servers) {
		$p = &SecureHtml($p);
		push(@hiddens, "<input type=\"hidden\" name=\"PING_SERVERS\" value=\"${p}\">");
	}
	delete $in{'PING_SERVERS'};
	for my $key (keys %in) {
		my $value = &SecureHtml($in{$key});
		push(@hiddens, "<input type=\"hidden\" name=\"${key}\" value=\"${value}\">");
		$value =~ s/\n/<br>\n/g;
		if($key eq 'ITEM_LINK') {
			$html =~ s/\$${key}\$/<a href=\"$in{'ITEM_LINK'}\" target=\"_blank\">${value}<\/a>/g;
		} else {
			$html =~ s/\$${key}\$/${value}/g;
		}
	}
	my $hidden_tag = join("\n", @hiddens);
	$html =~ s/\$HIDDEN\$/${hidden_tag}/;
	$html =~ s/\$itemid\$/${itemid}/g;
	#ʏo
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub ItemDel {
	my($items_ref) = @_;
	for my $id (@{$items_ref}) {
		unless($id =~ /^\d{12}$/) {next;}
		unlink "$CONF{'DATA_DIR'}/${id}.cgi";
	}
}

sub ItemDelCheck {
	my($items_ref) = @_;
	my @del_items = @{$items_ref};
	my $num = scalar @del_items;
	if($num < 1) {
		&ErrorPrint("폜LɃ`FbNĉB");
	}
	my $file_exist_flag = 1;
	for my $id (@del_items) {
		unless($id =~ /^\d{12}$/) {
			$file_exist_flag = 0;
			last;
		}
		unless(-e "$CONF{'DATA_DIR'}/${id}.cgi") {
			$file_exist_flag = 0;
			last;
		}
	}
	unless($file_exist_flag) {
		&ErrorPrint("sȒlM܂B");
	}
}

sub UpdateRss {
	#RSS1.0@C𐶐
	if($CONF{'FORMAT_RSS10'}) {
		&GenerateRss10;
	}
	#RSS2.0𐶐
	if($CONF{'FORMAT_RSS20'}) {
		&GenerateRss20;
	}
	#Atom𐶐
	#if($CONF{'FORMAT_ATOM'}) {
	#	&GenerateAtom;
	#}
	#HTML𐶐
	if($CONF{'HTML_FLAG'}) {
		&GenerateHtml;
	}
}

sub PrintItemModForm {
	my $itemid = $q->param('itemid');
	unless($itemid =~ /^\d{12}$/) {
		&ErrorPrint("sȒlM܂B");
	}
	#o^e擾
	my %item_data = &GetItemData("$CONF{'DATA_DIR'}/${itemid}.cgi");
	#ev[gǂݎ
	my $html = &ReadTemplate("./template/admin/itemmod.html");
	#uwqu
	#su
	my @pubdate = gmtime($item_data{'PUBDATE_EPOCH'} + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
	$pubdate[5] += 1900;
	$pubdate[4] ++;
	$html =~ s/\$YEAR\$/$pubdate[5]/;
	$html =~ s/\$MON\$/$pubdate[4]/;
	$html =~ s/\$DAY\$/$pubdate[3]/;
	$html =~ s/\$HOUR\$/$pubdate[2]/;
	$html =~ s/\$MIN\$/$pubdate[1]/;
	$html =~ s/\$SEC\$/$pubdate[0]/;
	#JeS[
	my @categories = &GetCategoryList;
	my $cate_html;
	$cate_html .= "<select name=\"CATEGORY\">\n";
	$cate_html .= "  <option value=\"\">w</option>\n";
	for my $cate (@categories) {
		my $selected = '';
		if($cate eq $item_data{'CATEGORY'}) {
			$selected = ' selected';
		}
		$cate = &SecureHtml($cate);
		$cate_html .= "  <option value=\"${cate}\"${selected}>${cate}</option>\n";
	}
	$cate_html .= "</select>\n";
	$html =~ s/\$CATEGORIES\$/${cate_html}/g;
	#L^Cgu
	$item_data{'ITEM_TITLE'} = &SecureHtml($item_data{'ITEM_TITLE'});
	$html =~ s/\$ITEM_TITLE\$/$item_data{'ITEM_TITLE'}/g;
	#LURLu
	$html =~ s/\$ITEM_LINK\$/$item_data{'ITEM_LINK'}/g;
	#LTvu
	$item_data{'ITEM_DESCRIPTION'} = &SecureHtml($item_data{'ITEM_DESCRIPTION'});
	$html =~ s/\$ITEM_DESCRIPTION\$/$item_data{'ITEM_DESCRIPTION'}/g;
	#҂u
	$item_data{'AUTHOR_NAME'} = &SecureHtml($item_data{'AUTHOR_NAME'});
	$html =~ s/\$AUTHOR_NAME\$/$item_data{'AUTHOR_NAME'}/g;
	#҃[AhXu
	$item_data{'AUTHOR_ADDRESS'} = &SecureHtml($item_data{'AUTHOR_ADDRESS'});
	$html =~ s/\$AUTHOR_ADDRESS\$/$item_data{'AUTHOR_ADDRESS'}/g;
	#XVpingT[oꗗ
	if($CONF3{'PING_FLAG'} eq '1' || $CONF3{'PING_TIMING'} eq '1') {
		$html =~ s/\$ping\$//;
	} else {
		my $ping_list_html;
		my @pings = split(/\t/, $CONF3{'PING_SERVERS'});
		my $checked;
		if($CONF3{'PING_FLAG'} eq '2') {
			$checked = '';
		} elsif($CONF3{'PING_FLAG'} eq '3') {
			$checked = ' checked';
		}
		for my $p (@pings) {
			$p = &SecureHtml($p);
			$ping_list_html .= "<input type=\"checkbox\" name=\"PING_SERVERS\" value=\"${p}\"${checked}>${p}<br>\n";
		}
		$html =~ s/\$ping\$/${ping_list_html}/;
	}
	#LIDu
	$html =~ s/\$itemid\$/${itemid}/g;
	#ʂo
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintItemList {
	#Lf[^荞݁AXgHTML𐶐
	opendir(DIR, "$CONF{'DATA_DIR'}") or &ErrorPrint("Lf[^i[fBNgI[vł܂łB: $!");
	my @files = readdir(DIR);
	closedir(DIR);
	my $list_html;
	$list_html .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" class=\"form_table\">\n";
	$list_html .= "<tr>\n";
	$list_html .= "<td class=\"form_title_cell\" nowrap>s</td>\n";
	$list_html .= "<td class=\"form_title_cell\" nowrap>JeS[</td>\n";
	$list_html .= "<td class=\"form_title_cell\" nowrap>L^Cg</td>\n";
	$list_html .= "<td class=\"form_title_cell\" nowrap>폜</td>\n";
	$list_html .= "</tr>\n";
	my $i = 1;
	for my $file (sort {$b cmp $a} @files) {
		my $itemid;
		if($file =~ /^(\d{12})\.cgi$/) {
			$itemid = $1;
		} else {
			next;
		}
		my %item_data = &GetItemData("$CONF{'DATA_DIR'}/${file}");
		my @pubdate = gmtime($item_data{'PUBDATE_EPOCH'} + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
		$pubdate[5] += 1900;
		$pubdate[4] ++;
		for(my $i=0; $i<=4; $i++) {
			$pubdate[$i] = sprintf("%02d", $pubdate[$i]);
		}
		my $category = $item_data{'CATEGORY'};
		if(length($category) > 12) {
			$category = &TruncateSjisString($category, 10);
			$category .= "...";
		}
		$category = &SecureHtml($category);
		my $title = $item_data{'ITEM_TITLE'};
		if(length($title) > 60) {
			$title = &TruncateSjisString($title, 58);
			$title .= "...";
		}
		$title = &SecureHtml($title);
		my $bgcolor = '#F8F8FB';
		if($i > $CONF{'RSS_PRINT_NUM'}) {
			$bgcolor = '#DDDDDD';
		}
		$list_html .= "<tr>\n";
		$list_html .= "<td bgcolor=\"${bgcolor}\" nowrap>$pubdate[5]\/$pubdate[4]\/$pubdate[3]</td>\n";
		$list_html .= "<td bgcolor=\"${bgcolor}\" nowrap>${category}</td>\n";
		$list_html .= "<td bgcolor=\"${bgcolor}\" nowrap><a href=\"${CGI_URL}?a=itemmodform&itemid=${itemid}\">${title}</a></td>\n";
		$list_html .= "<td bgcolor=\"${bgcolor}\" nowrap><input type=\"checkbox\" name=\"itemid\" value=\"${itemid}\"></td>\n";
		$list_html .= "</tr>\n";
		$i++;
	}
	$list_html .= "</table>\n";
	#ʃev[gǂݎ
	my $html = &ReadTemplate("./template/admin/itemlist.html");
	#uwqu
	$html =~ s/\$LIST\$/${list_html}/;
	#ʂo
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub GenerateHtml {
	#Charset
	my %charset_list = (
		'1' => 'sjis',
		'2' => 'euc',
		'3' => 'utf8'
	);
	my $charset = $charset_list{$CONF{'HTML_CHARSET'}};
	unless($charset) {
		$charset = 'sjis';
	}
	#ev[gǂݎ
	my $t_file = "./template/rss/custom.new.html";
	unless(-e $t_file) {
		$t_file = "./template/rss/new.html";
	}
	my $t_size = -s $t_file;
	if(!open(IN, "$t_file")) {
		&ErrorPrint2("ev[gt@C $t_file I[vł܂łB : $!");
	}
	binmode(IN);
	my $template_data;
	sysread(IN, $template_data, $t_size);
	close(IN);
	&Jcode::convert(\$template_data, "$charset");
	my $template = HTML::Template->new(
		scalarref => \$template_data,
		die_on_bad_params => 0,
		vanguard_compatibility_mode => 1
	);
	#channel::title
	my $channel_title = $CONF2{'CHANNEL_TITLE'};
	$channel_title = &SecureHtml($channel_title);
	&Jcode::convert(\$channel_title, "$charset", 'sjis');
	#channel::description
	my $channel_description = $CONF2{'CHANNEL_DESCRIPTION'};
	$channel_description = MIME::Base64::Perl::decode_base64($channel_description);
	$channel_description = &SecureHtml($channel_description);
	&Jcode::convert(\$channel_description, "$charset", 'sjis');
	#<item>
	my(@seq_array, @item_array);
	opendir(DIR, "$CONF{'DATA_DIR'}") or &ErrorPrint("Lf[^i[fBNgI[vł܂łB: $!");
	my @files = readdir(DIR);
	closedir(DIR);
	my $n = 0;
	for my $file (sort {$b cmp $a} @files) {
		if($file !~ /^\d{12}\.cgi$/) {next;}
		my %item_data = &GetItemData("$CONF{'DATA_DIR'}/${file}");
		#<item>
		my %item_hash;
		$item_hash{'ITEM_LINK'} = $item_data{'ITEM_LINK'};
		my $item_title = &SecureHtml($item_data{'ITEM_TITLE'});
		&Jcode::convert(\$item_title, "$charset", 'sjis');
		$item_hash{'ITEM_TITLE'} = $item_title;
		my $item_description = &SecureHtml($item_data{'ITEM_DESCRIPTION'});
		&Jcode::convert(\$item_description, "$charset", 'sjis');
		$item_hash{'ITEM_DESCRIPTION'} = $item_description;
		my $item_category = &SecureHtml($item_data{'CATEGORY'});
		&Jcode::convert(\$item_category, "$charset", 'sjis');
		$item_hash{'ITEM_CATEGORY'} = $item_category;
		my @item_pubdate = gmtime($item_data{'PUBDATE_EPOCH'} + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
		$item_pubdate[5] += 1900;
		$item_pubdate[4] ++;
		for(my $i=0; $i<=4; $i++) {
			$item_pubdate[$i] = sprintf("%02d", $item_pubdate[$i]);
		}
		$item_hash{'ITEM_PUB_DATE'} = "$item_pubdate[5]/$item_pubdate[4]/$item_pubdate[3]";

		push(@item_array, \%item_hash);

		$n ++;
		if($n >= $CONF{'HTML_PRINT_NUM'}) {
			last;
		}
	}
	#ev[gϊ
	$template->param('ITEM' => \@item_array);
	$template->param('CHANNEL_TITLE' => $channel_title);
	$template->param('CHANNEL_LINK' => $CONF2{'CHANNEL_LINK'});
	$template->param('CHANNEL_DESCRIPTION' => $channel_description);
	#RSSt@Cɏo͂
	my $html = $template->output;
	open(FILE, ">$CONF{'HTML_PATH'}") or &ErrorPrint("HTMLt@CɎs܂B: $!");
	print FILE $html;
	close(FILE);
}

sub GenerateRss20 {
	#ev[gǂݎ
	my $template = HTML::Template->new(
		filename => "./template/rss/rss20.xml",
		die_on_bad_params => 0,
		vanguard_compatibility_mode => 1
	);
	#channel::title
	my $channel_title = $CONF2{'CHANNEL_TITLE'};
	$channel_title = &SecureHtml($channel_title);
	&Jcode::convert(\$channel_title, 'utf8', 'sjis');
	#channel::description
	my $channel_description = $CONF2{'CHANNEL_DESCRIPTION'};
	$channel_description = MIME::Base64::Perl::decode_base64($channel_description);
	$channel_description = &SecureHtml($channel_description);
	&Jcode::convert(\$channel_description, 'utf8', 'sjis');
	#channel::editor
	my $channel_editor = $CONF2{'CHANNEL_CREATOR_MAIL'};
	if($CONF2{'CHANNEL_CREATOR'}) {
		my $channel_creater = &SecureHtml($CONF2{'CHANNEL_CREATOR'});
		&Jcode::convert(\$channel_creater, 'utf8', 'sjis');
		$channel_editor .= " \(${channel_creater}\)";
	}
	#channel::copyright
	my $channel_copyright = $CONF2{'CHANNEL_COPYRIGHT'};
	$channel_copyright = &SecureHtml($channel_copyright);
	&Jcode::convert(\$channel_copyright, 'utf8', 'sjis');
	#channel::pubdate
	my @pubdate = gmtime(time + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
	my @week_strings = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
	$pubdate[6] = $week_strings[$pubdate[6]];
	$pubdate[5] += 1900;
	my @month_strings = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
	$pubdate[4] = $month_strings[$pubdate[4]];
	for(my $i=0; $i<=3; $i++) {
		$pubdate[$i] = sprintf("%02d", $pubdate[$i]);
	}
	my $tz_sign = '+';
	if($CONF{'TIMEZONE_OFFSET'} =~ /^\-/) {
		$tz_sign = '-';
	}
	my $tz = $tz_sign . sprintf("%02d", abs($CONF{'TIMEZONE_OFFSET'})) . ':00';
	my $channel_pub_date = "$pubdate[6], $pubdate[3] $pubdate[4] $pubdate[5] $pubdate[2]:$pubdate[1]:$pubdate[0] ${tz}";
	#image::title
	my $image_title = $CONF2{'IMAGE_TITLE'};
	$image_title = &SecureHtml($image_title);
	&Jcode::convert(\$image_title, 'utf8', 'sjis');
	#<item>
	my(@seq_array, @item_array);
	opendir(DIR, "$CONF{'DATA_DIR'}") or &ErrorPrint("Lf[^i[fBNgI[vł܂łB: $!");
	my @files = readdir(DIR);
	closedir(DIR);
	my $n = 0;
	for my $file (sort {$b cmp $a} @files) {
		if($file !~ /^\d{12}\.cgi$/) {next;}
		my %item_data = &GetItemData("$CONF{'DATA_DIR'}/${file}");
		#<item>
		my %item_hash;
		$item_hash{'ITEM_LINK'} = $item_data{'ITEM_LINK'};
		my $item_title = &SecureHtml($item_data{'ITEM_TITLE'});
		&Jcode::convert(\$item_title, 'utf8', 'sjis');
		$item_hash{'ITEM_TITLE'} = $item_title;
		my $item_description = &SecureHtml($item_data{'ITEM_DESCRIPTION'});
		&Jcode::convert(\$item_description, 'utf8', 'sjis');
		$item_hash{'ITEM_DESCRIPTION'} = $item_description;
		my $item_author = $item_data{'AUTHOR_ADDRESS'};
		if($item_data{'AUTHOR_NAME'}) {
			my $author_name = &SecureHtml($item_data{'AUTHOR_NAME'});
			&Jcode::convert(\$author_name, 'utf8', 'sjis');
			$item_author .= " \(${author_name}\)";
		}
		$item_hash{'ITEM_AUTHOR'} = $item_author;

		my $item_category = &SecureHtml($item_data{'CATEGORY'});
		&Jcode::convert(\$item_category, 'utf8', 'sjis');
		$item_hash{'ITEM_CATEGORY'} = $item_category;
		my @item_pubdate = gmtime($item_data{'PUBDATE_EPOCH'} + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
		$item_pubdate[6] = $week_strings[$item_pubdate[6]];
		$item_pubdate[5] += 1900;
		$item_pubdate[4] = $month_strings[$item_pubdate[4]];
		for(my $i=0; $i<=3; $i++) {
			$item_pubdate[$i] = sprintf("%02d", $item_pubdate[$i]);
		}
		$item_hash{'ITEM_PUB_DATE'} = "$item_pubdate[6], $item_pubdate[3] $item_pubdate[4] $item_pubdate[5] $item_pubdate[2]:$item_pubdate[1]:$item_pubdate[0] ${tz}";

		push(@item_array, \%item_hash);

		$n ++;
		if($n >= $CONF{'RSS_PRINT_NUM'}) {
			last;
		}
	}
	#ev[gϊ
	$template->param('ITEM' => \@item_array);
	$template->param('CHANNEL_TITLE' => $channel_title);
	$template->param('CHANNEL_LINK' => $CONF2{'CHANNEL_LINK'});
	$template->param('CHANNEL_DESCRIPTION' => $channel_description);
	$template->param('CHANNEL_EDITOR' => $channel_editor);
	$template->param('CHANNEL_COPYRIGHT' => $channel_copyright);
	$template->param('CHANNEL_PUB_DATE' => $channel_pub_date);
	if($CONF2{'IMAGE_FLAG'}) {
		$template->param('IMAGE_FLAG' => 1);
		$template->param('IMAGE_URL' => $CONF2{'IMAGE_URL'});
		$template->param('IMAGE_TITLE' => $image_title);
		$template->param('IMAGE_LINK' => $CONF2{'IMAGE_LINK'});
	}
	$template->param('VERSION' => $VERSION);
	#RSSt@Cɏo͂
	my $rss = $template->output;
	open(FILE, ">$CONF{'FILE_PATH_RSS20'}") or &ErrorPrint("RSS2.0t@CɎs܂B: $!");
	print FILE $rss;
	close(FILE);
}

sub GenerateRss10 {
	#ev[gǂݎ
	my $template = HTML::Template->new(
		filename => "./template/rss/rss10.xml",
		die_on_bad_params => 0,
		vanguard_compatibility_mode => 1
	);
	#channel::title
	my $channel_title = $CONF2{'CHANNEL_TITLE'};
	$channel_title = &SecureHtml($channel_title);
	&Jcode::convert(\$channel_title, 'utf8', 'sjis');
	#channel::description
	my $channel_description = $CONF2{'CHANNEL_DESCRIPTION'};
	$channel_description = MIME::Base64::Perl::decode_base64($channel_description);
	$channel_description = &SecureHtml($channel_description);
	&Jcode::convert(\$channel_description, 'utf8', 'sjis');
	#channel::publishuer
	my $channel_publishuer = $CONF2{'CHANNEL_PUBLISHER'};
	$channel_publishuer = &SecureHtml($channel_publishuer);
	&Jcode::convert(\$channel_publishuer, 'utf8', 'sjis');
	#channel::creater
	my $channel_creater = $CONF2{'CHANNEL_CREATOR'};
	$channel_creater = &SecureHtml($channel_creater);
	&Jcode::convert(\$channel_creater, 'utf8', 'sjis');
	#channel::copyright
	my $channel_copyright = $CONF2{'CHANNEL_COPYRIGHT'};
	$channel_copyright = &SecureHtml($channel_copyright);
	&Jcode::convert(\$channel_copyright, 'utf8', 'sjis');
	#channel::pubdate
	my @pubdate = gmtime(time + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
	$pubdate[5] += 1900;
	$pubdate[4] ++;
	for(my $i=0; $i<=4; $i++) {
		$pubdate[$i] = sprintf("%02d", $pubdate[$i]);
	}
	my $tz_sign = '+';
	if($CONF{'TIMEZONE_OFFSET'} =~ /^\-/) {
		$tz_sign = '-';
	}
	my $tz = $tz_sign . sprintf("%02d", abs($CONF{'TIMEZONE_OFFSET'})) . ':00';
	my $channel_pub_date = "$pubdate[5]\-$pubdate[4]-$pubdate[3]T$pubdate[2]:$pubdate[1]:$pubdate[0]${tz}";
	#image::title
	my $image_title = $CONF2{'IMAGE_TITLE'};
	$image_title = &SecureHtml($image_title);
	&Jcode::convert(\$image_title, 'utf8', 'sjis');
	#<rdf:Seq>, <item>
	my(@seq_array, @item_array);
	opendir(DIR, "$CONF{'DATA_DIR'}") or &ErrorPrint("Lf[^i[fBNgI[vł܂łB: $!");
	my @files = readdir(DIR);
	closedir(DIR);
	my $n = 0;
	for my $file (sort {$b cmp $a} @files) {
		if($file !~ /^\d{12}\.cgi$/) {next;}
		my %item_data = &GetItemData("$CONF{'DATA_DIR'}/${file}");
		#<rdf:Seq>
		my %seq_hash;
		$seq_hash{'ITEM_LINK'} = $item_data{'ITEM_LINK'};
		push(@seq_array, \%seq_hash);
		#<item>
		my %item_hash;
		$item_hash{'ITEM_LINK'} = $item_data{'ITEM_LINK'};
		my $item_title = &SecureHtml($item_data{'ITEM_TITLE'});
		&Jcode::convert(\$item_title, 'utf8', 'sjis');
		$item_hash{'ITEM_TITLE'} = $item_title;
		my $item_description = &SecureHtml($item_data{'ITEM_DESCRIPTION'});
		&Jcode::convert(\$item_description, 'utf8', 'sjis');
		$item_hash{'ITEM_DESCRIPTION'} = $item_description;
		$item_hash{'CHANNEL_PUBLISHER'} = $channel_publishuer;
		my $item_creator = &SecureHtml($item_data{'AUTHOR_NAME'});
		&Jcode::convert(\$item_creator, 'utf8', 'sjis');
		$item_hash{'ITEM_CREATOR'} = $item_creator;
		my $item_category = &SecureHtml($item_data{'CATEGORY'});
		&Jcode::convert(\$item_category, 'utf8', 'sjis');
		$item_hash{'ITEM_CATEGORY'} = $item_category;
		my @item_pubdate = gmtime($item_data{'PUBDATE_EPOCH'} + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
		$item_pubdate[5] += 1900;
		$item_pubdate[4] ++;
		for(my $i=0; $i<=4; $i++) {
			$item_pubdate[$i] = sprintf("%02d", $item_pubdate[$i]);
		}
		$item_hash{'ITEM_PUB_DATE'} = "$item_pubdate[5]\-$item_pubdate[4]-$item_pubdate[3]T$item_pubdate[2]:$item_pubdate[1]:$item_pubdate[0]${tz}";
		push(@item_array, \%item_hash);

		$n ++;
		if($n >= $CONF{'RSS_PRINT_NUM'}) {
			last;
		}
	}
	#ev[gϊ
	$template->param('RDF_SEQ' => \@seq_array);
	$template->param('ITEM' => \@item_array);
	$template->param('CHANNEL_TITLE' => $channel_title);
	$template->param('CHANNEL_LINK' => $CONF2{'CHANNEL_LINK'});
	$template->param('CHANNEL_DESCRIPTION' => $channel_description);
	$template->param('CHANNEL_PUBLISHER' => $channel_publishuer);
	$template->param('CHANNEL_CREATOR' => $channel_creater);
	$template->param('CHANNEL_COPYRIGHT' => $channel_copyright);
	$template->param('CHANNEL_PUB_DATE' => $channel_pub_date);
	if($CONF2{'IMAGE_FLAG'}) {
		$template->param('IMAGE_FLAG' => 1);
		$template->param('IMAGE_URL' => $CONF2{'IMAGE_URL'});
		$template->param('IMAGE_TITLE' => $image_title);
		$template->param('IMAGE_LINK' => $CONF2{'IMAGE_LINK'});
	}
	$template->param('VERSION' => $VERSION);
	#RSSt@Cɏo͂
	my $rss = $template->output;
	open(FILE, ">$CONF{'FILE_PATH_RSS10'}") or &ErrorPrint("RSS1.0t@CɎs܂B: $!");
	print FILE $rss;
	close(FILE);
}

sub GetItemData {
	my($file) = @_;
	open(FILE, "${file}");
	my %hash;
	while(my $line = <FILE>) {
		my($key, $value) = $line =~ /^([^\t]+)\t(.*)/;
		$value = MIME::Base64::Perl::decode_base64($value);
		$hash{$key} = $value;
	}
	close(FILE);
	return %hash;
}

sub DeletePastItems {
	opendir(DIR, "$CONF{'DATA_DIR'}") or &ErrorPrint("Lf[^i[fBNgI[vł܂łB: $!");
	my @files = readdir(DIR);
	closedir(DIR);
	my $n = 0;
	for my $file (sort {$b cmp $a} @files) {
		if($file !~ /^\d{12}\.cgi$/) {next;}
		$n ++;
		if($n > $CONF{'SAVED_NUM'}) {
			unlink "$CONF{'DATA_DIR'}/${file}";
		}
	}
}

sub WriteItemData {
	my($item_id, $data_ref) = @_;
	#t@Cɏރf[^𒊏o
	my %data;
	$data{'PUBDATE_EPOCH'}    = $data_ref->{'PUBDATE_EPOCH'};
	$data{'CATEGORY'}         = $data_ref->{'CATEGORY'};
	$data{'ITEM_TITLE'}       = $data_ref->{'ITEM_TITLE'};
	$data{'ITEM_LINK'}        = $data_ref->{'ITEM_LINK'};
	$data{'ITEM_DESCRIPTION'} = $data_ref->{'ITEM_DESCRIPTION'};
	$data{'AUTHOR_NAME'}      = $data_ref->{'AUTHOR_NAME'};
	$data{'AUTHOR_ADDRESS'}   = $data_ref->{'AUTHOR_ADDRESS'};

	#t@C֏
	my $file = "$CONF{'DATA_DIR'}/${item_id}.cgi";
	open(FILE, ">${file}") or &ErrorPrint("Lf[^t@Cւ݂̏Ɏs܂B: $!");
	for my $key (sort keys %data) {
		my $value = &UnifyReturnCode($data{$key});
		$value = MIME::Base64::Perl::encode_base64($value, '');
		print FILE "${key}\t${value}\n";
	}
	close(FILE);
}

sub ItemAddToDb {
	#͒l`FbN
	my %in = &ItemInputCheck;
	#s
	if($in{'DATE_FLAG'} eq '2') {	#sʎw̏ꍇ
		for my $key ('SEC', 'MIN', 'HOUR', 'DAY', 'MON') {
			$in{$key} =~ s/^0+//;
		}
		$in{'PUBDATE_EPOCH'} = timegm($in{'SEC'}, $in{'MIN'}, $in{'HOUR'}, $in{'DAY'}, $in{'MON'} - 1, $in{'YEAR'} - 1900);
		$in{'PUBDATE_EPOCH'} -= ($CONF{'TIMEZONE_OFFSET'} * 3600);
	} else {
		$in{'PUBDATE_EPOCH'} = time;
		($in{'SEC'}, $in{'MIN'}, $in{'HOUR'}, $in{'DAY'}, $in{'MON'}, $in{'YEAR'}) = gmtime($in{'PUBDATE_EPOCH'} + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
		$in{'MON'} ++;
		$in{'YEAR'} += 1900;
	}
	#LID𐶐
	my $d = $in{'YEAR'} . sprintf("%02d", $in{'MON'}) . sprintf("%02d", $in{'DAY'});
	my $max_n = 0;
	opendir(DIR, "$CONF{'DATA_DIR'}") or &ErrorPrint("Lf[^i[fBNgI[vł܂łB: $!");
	my @files = readdir(DIR);
	closedir(DIR);
	for my $file (@files) {
		if($file =~ /^\d{8}(\d{4})\.cgi$/) {
			my $n = $1;
			$n =~ s/^0+//;
			if($n > $max_n) {
				$max_n = $n;
			}
		}
	}
	$max_n ++;
	if($max_n > 9999) {
		&ErrorPrint("1ɍ쐬łĽxI[o[܂̂ŁA𒆎~܂B1ɍ쐬łL9999܂łłB");
	}
	my $item_id = ${d} . sprintf("%04d", $max_n);
	#f[^t@C𐶐
	&WriteItemData($item_id, \%in);
}

sub ItemInputCheck {
	eval {
		require FCC::Net::http;
		require Image::Size;
	};
	if($@) {
		&ErrorPrint("W[̃[hɎs܂B<br>$@");
	}
	#͒li[Azz`
	my %in;
	$in{'DATE_FLAG'} = $q->param('DATE_FLAG');
	$in{'YEAR'} = $q->param('YEAR');
	$in{'MON'} = $q->param('MON');
	$in{'DAY'} = $q->param('DAY');
	$in{'HOUR'} = $q->param('HOUR');
	$in{'MIN'} = $q->param('MIN');
	$in{'SEC'} = $q->param('SEC');
	$in{'CATEGORY'} = $q->param('CATEGORY');
	$in{'ITEM_TITLE'} = $q->param('ITEM_TITLE');
	$in{'ITEM_LINK'} = $q->param('ITEM_LINK');
	$in{'ITEM_DESCRIPTION'} = $q->param('ITEM_DESCRIPTION');
	$in{'AUTHOR_NAME'} = $q->param('AUTHOR_NAME');
	$in{'AUTHOR_ADDRESS'} = $q->param('AUTHOR_ADDRESS');
	my @ping_servers = $q->param('PING_SERVERS');
	$in{'PING_SERVERS'} = [@ping_servers];

	#
	if($in{'DATE_FLAG'} eq '') {
		$in{'DATE_FLAG'} = '1';
	}
	my @date_key = ('YEAR', 'MON', 'DAY', 'HOUR', 'MIN', 'SEC');
	if($in{'DATE_FLAG'} eq '1') {
		for my $key (@date_key) {
			$in{$key} = '';
		}
	} elsif($in{'DATE_FLAG'} eq '2') {
		for my $key (@date_key) {
			$in{$key} =~ s/^0+//;
			if($in{$key} eq '') {
				$in{$key} eq '0';
			}
			if($in{$key} =~ /[^\d]/) {
				&ErrorPrint("s͔pŎw肵ĂB");
			}
		}
		if(length($in{'YEAR'}) != 4) {
			&ErrorPrint("s̐4Ŏw肵ĂB");
		}
		if($in{'YEAR'} < 1970) {
			&ErrorPrint("s̐1970NȑOw肷邱Ƃ͂ł܂B");
		}
		if($in{'MON'} < 1 || $in{'MON'} > 12) {
			&ErrorPrint("šsK؂łB");
		}
		if($in{'DAY'} < 1 || $in{'DAY'} > 31) {
			&ErrorPrint("s̓sK؂łB");
		}
		unless(&IsExistDate($in{'YEAR'}, $in{'MON'}, $in{'DAY'})) {
			&ErrorPrint("sɎw肵t݂͑܂B");
		}
		if($in{'HOUR'} < 0 || $in{'HOUR'} > 23) {
			&ErrorPrint("s̎ԂsK؂łB");
		}
		if($in{'MIN'} < 0 || $in{'MIN'} > 59) {
			&ErrorPrint("s̕sK؂łB");
		}
		if($in{'SEC'} < 0 || $in{'SEC'} > 59) {
			&ErrorPrint("s̕bsK؂łB");
		}
	} else {
		&ErrorPrint("sȒlM܂B: DATE_FLAG=$in{'DATE_FLAG'}");
	}
	#L^Cg
	if($in{'ITEM_TITLE'} eq '') {
		&ErrorPrint("L^Cg͂ĉ");
	}
	#LURL
	if($in{'ITEM_LINK'} eq '') {
		&ErrorPrint("LURL͂ĉ");
	} else {
		unless(&UrlCheck($in{'ITEM_LINK'})) {
			&ErrorPrint("LURL܂B");
		}
		if($in{'ITEM_LINK'} =~ /^http\:\/\//i) {
			my($header, $res);
			FCC::Net::http::head($in{'ITEM_LINK'}, \$header, \$res);
			if($res) {
				&ErrorPrint("<p>LURLɎw肵URL͐܂B</p><p>$in{'ITEM_LINK'}</p><pre>${res}</pre>");
			}
		}
	}
	#҃[AhX
	if($in{'AUTHOR_ADDRESS'}) {
		unless(&MailAddressCheck($in{'AUTHOR_ADDRESS'})) {
			&ErrorPrint("҃[AhX܂B");
		}
	}
	#͒li[AzzԂ
	return %in;
}

sub UrlCheck {
	my($url) = @_;
	unless($url =~ /^https*:\/\/[^\/]+/) {
		return;
	}
	if($url =~ /[^0-9a-zA-Z\:\/\.\-\_\#\%\&\=\~\+\?]/) {
		return;
	}
	return 1;
}

sub IsExistDate {
   my($year, $mon, $day) = @_;
   #timelocal֐ŒvIG[ƂȂ邩ǂ`FbN
   my $result;
   eval {$result = timelocal(0, 0, 0, $day, $mon-1, $year-1900);};
   #G[ƂȂ΁AsK؂ȓtȂ̂ŁA0Ԃ
   if($@) {return 0;}
   #timelocalΏł鐼͈̔͊O`FbN
   #timelocal֐́A͈͊O̐^-1Ԃ
   if($result < 0) {return 0;}
   #1̃G|bNbo
   if($mon == 12) {
      $mon = 0;
      $year ++;
   }
   my $time = timelocal(0, 0, 12, 1, $mon, $year-1900);
   #oG|bNb1̕bA
   #̑OA܂w茎̌̃G|bNb߂
   $time -= 60*60*24;
   #w茎̌̏o
   my @date = localtime($time);
   #wAw茎傫΁A
   #sK؂ȓtȂ̂0Ԃ
   if($day > $date[3]) {return 0;}
   #ȏ̃`FbNNÂŁA݂tł
   return 1;
}

sub PrintItemAddConfirm {
	#ʃev[gHTMLǂݍ
	my $html = &ReadTemplate("./template/admin/itemaddconfirm.html");
	#͒l`FbN
	my %in = &ItemInputCheck;
	#uwqu/hidden^O
	my @hiddens;
	if($in{'DATE_FLAG'} eq '2') {
		my $mon = sprintf("%02d", $in{'MON'});
		my $day = sprintf("%02d", $in{'DAY'});
		my $hour = sprintf("%02d", $in{'HOUR'});
		my $min = sprintf("%02d", $in{'MIN'});
		my $sec = sprintf("%02d", $in{'SEC'});
		my $date = "$in{'YEAR'}/${mon}/${day} ${hour}:${min}:${sec}";
		$html =~ s/\$DATE\$/${date}/g;
	} else {
		$html =~ s/\$DATE\$/ݒ/g;
	}
	my @ping_servers = @{$in{'PING_SERVERS'}};
	my $ping_html = join("<br>\n", @ping_servers);
	$html =~ s/\$PING_SERVERS\$/${ping_html}/;
	for my $p (@ping_servers) {
		$p = &SecureHtml($p);
		push(@hiddens, "<input type=\"hidden\" name=\"PING_SERVERS\" value=\"${p}\">");
	}
	delete $in{'PING_SERVERS'};
	for my $key (keys %in) {
		my $value = &SecureHtml($in{$key});
		push(@hiddens, "<input type=\"hidden\" name=\"${key}\" value=\"${value}\">");
		$value =~ s/\n/<br>\n/g;
		if($key eq 'ITEM_LINK') {
			$html =~ s/\$${key}\$/<a href=\"$in{'ITEM_LINK'}\" target=\"_blank\">${value}<\/a>/g;
		} else {
			$html =~ s/\$${key}\$/${value}/g;
		}
	}
	my $hidden_tag = join("\n", @hiddens);
	$html =~ s/\$HIDDEN\$/${hidden_tag}/;
	#ʏo
	my $content_length = length $html;
	#print "Cache-Control: no-cache\n";
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintItemAddForm {
	my $html = &ReadTemplate("./template/admin/itemadd.html");
	#JeS[ꗗ
	my @categories = &GetCategoryList;
	my $cate_html;
	$cate_html .= "<select name=\"CATEGORY\">\n";
	$cate_html .= "  <option value=\"\">w</option>\n";
	for my $cate (@categories) {
		$cate = &SecureHtml($cate);
		$cate_html .= "  <option value=\"${cate}\">${cate}</option>\n";
	}
	$cate_html .= "</select>\n";
	$html =~ s/\$CATEGORIES\$/${cate_html}/g;
	#XVpingT[oꗗ
	if($CONF3{'PING_FLAG'} eq '1') {
		$html =~ s/\$ping\$//;
	} else {
		my $ping_list_html;
		my @pings = split(/\t/, $CONF3{'PING_SERVERS'});
		my $checked;
		if($CONF3{'PING_FLAG'} eq '2') {
			$checked = '';
		} elsif($CONF3{'PING_FLAG'} eq '3') {
			$checked = ' checked';
		}
		for my $p (@pings) {
			$p = &SecureHtml($p);
			$ping_list_html .= "<input type=\"checkbox\" name=\"PING_SERVERS\" value=\"${p}\"${checked}>${p}<br>\n";
		}
		$html =~ s/\$ping\$/${ping_list_html}/;
	}
	#ݓ
	my($sec, $min, $hour, $day, $mon, $year) = gmtime(time + ($CONF{'TIMEZONE_OFFSET'} * 3600) );
	$year += 1900;
	$mon ++;
	#̑uwqu
	my $auther_name = $CONF2{'CHANNEL_CREATOR'};
	my $auther_address = $CONF2{'CHANNEL_CREATOR_MAIL'};
	$auther_name = &SecureHtml($auther_name);
	$auther_address = &SecureHtml($auther_address);
	$html =~ s/\$AUTHOR_NAME\$/${auther_name}/g;
	$html =~ s/\$AUTHOR_ADDRESS\$/${auther_address}/g;
	$html =~ s/\$YEAR\$/${year}/g;
	$html =~ s/\$MON\$/${mon}/g;
	$html =~ s/\$DAY\$/${day}/g;
	$html =~ s/\$HOUR\$/${hour}/g;
	$html =~ s/\$MIN\$/${min}/g;
	$html =~ s/\$SEC\$/${sec}/g;
	#ʏo
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub SetConf3 {
	#͒l擾B
	my %in = %CONF3;
	$in{'PING_FLAG'} = $q->param('PING_FLAG');
	$in{'PING_TIMING'} = $q->param('PING_TIMING');
	$in{'PING_SERVERS'} = $q->param('PING_SERVERS');
	#sR[h𓝈ꂷ
	while( my($key, $value) = each %in ) {
		$value = &UnifyReturnCode($value);
		$in{$key} = $value;
	}
	#ꂼ̓͒l`FbN
	#XVpings[
	if($in{'PING_FLAG'} eq '') {
		$in{'PING_FLAG'} = '1';
	} elsif($in{'PING_FLAG'} !~ /^(1|2|3)$/) {
		&ErrorPrint("sȒlM܂BPING_FLAG");
	}
	#XVpings^C~O
	if($in{'PING_TIMING'} eq '') {
		$in{'PING_TIMING'} = '1';
	} elsif($in{'PING_TIMING'} !~ /^(1|2)$/) {
		&ErrorPrint("sȒlM܂BPING_TIMING");
	}
	#pingT[o
	if($in{'PING_FLAG'} ne '1') {
		if($in{'PING_SERVERS'} eq '') {
			&ErrorPrint("pingT[ow肵ĉB");
		}
	}
	if($in{'PING_SERVERS'} ne '') {
		my @lines = split(/\n/, $in{'PING_SERVERS'});
		my @servers;
		for my $line (@lines) {
			$line =~ s/^\s+//;
			$line =~ s/\s+$//;
			if($line eq '') {next;}
			unless(&UrlCheck($line)) {
				my $disp_line = &SecureHtml($line);
				&ErrorPrint("pingT[oURLsK؂łB<br><tt>${disp_line}</tt>");
			}
			push(@servers, $line);
		}
		$in{'PING_SERVERS'} = join("\t", @servers);
	}
	#ݒ
	&WriteConf('./conf/ping.cgi', \%in);
}

sub PrintConf3Form {
	my $html = &ReadTemplate("./template/admin/conf3.html");
	if($CONF3{'PING_FLAG'} eq '') {
		$CONF3{'PING_FLAG'} = '1';
	}
	if($CONF3{'PING_TIMING'} eq '') {
		$CONF3{'PING_TIMING'} eq '1';
	}
	my $ping_servers_string = $CONF3{'PING_SERVERS'};
	$ping_servers_string =~ s/\t/\n/g;
	$CONF3{'PING_SERVERS'} = $ping_servers_string;
	while( my($key, $value) = each %CONF3) {
		$value = &SecureHtml($value);
		if($key =~ /^(PING_FLAG|PING_TIMING)$/) {
			$html =~ s/\s*\$${key}${value}\$/ checked/;
			$html =~ s/\s*\$${key}[0-9]+\$//g;
		} else {
			$html =~ s/\$${key}\$/${value}/g;
		}
	}
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub GetCategoryList {
	my @categories = split(/\t/, $CONF2{'CATEGORIES'});
	return @categories;
}

sub UrlEncode {
   my($string) = @_;
   #pXy[X"+"ɕϊ
   $string =~ s/ /+/g;
   #pp"+"łȂGR[h
   $string =~ s/([^A-Za-z0-9\+])/'%'.unpack("H2", $1)/ego;
   return $string;
}

sub SetConf2 {
	eval {
		require FCC::Net::http;
		require Image::Size;
	};
	if($@) {
		&ErrorPrint("W[̃[hɎs܂B<br>$@");
	}
	#͒l擾B
	my %in = %CONF2;
	$in{'CHANNEL_TITLE'} = $q->param('CHANNEL_TITLE');
	$in{'CHANNEL_LINK'} = $q->param('CHANNEL_LINK');
	$in{'CHANNEL_COPYRIGHT'} = $q->param('CHANNEL_COPYRIGHT');
	$in{'CHANNEL_DESCRIPTION'} = $q->param('CHANNEL_DESCRIPTION');
	$in{'CHANNEL_PUBLISHER'} = $q->param('CHANNEL_PUBLISHER');
	$in{'CHANNEL_CREATOR'} = $q->param('CHANNEL_CREATOR');
	$in{'CHANNEL_CREATOR_MAIL'} = $q->param('CHANNEL_CREATOR_MAIL');
	$in{'IMAGE_FLAG'} = $q->param('IMAGE_FLAG');
	$in{'IMAGE_URL'} = $q->param('IMAGE_URL');
	$in{'IMAGE_TITLE'} = $q->param('IMAGE_TITLE');
	$in{'IMAGE_LINK'} = $q->param('IMAGE_LINK');
	$in{'CATEGORIES'} = $q->param('CATEGORIES');
	#sR[h𓝈ꂷ
	while( my($key, $value) = each %in ) {
		$value = &UnifyReturnCode($value);
		$in{$key} = $value;
	}
	#ꂼ̓͒l`FbN
	#TCg
	if($in{'CHANNEL_TITLE'} eq '') {
		&ErrorPrint("uTCǵv͂ĉB");
	} else {
		$in{'CHANNEL_TITLE'} =~ s/\t//g;
		$in{'CHANNEL_TITLE'} =~ s/^\s+//;
		$in{'CHANNEL_TITLE'} =~ s/\s+$//;
		$in{'CHANNEL_TITLE'} =~ s/\n//g;
	}
	#TCgURL
	if($in{'CHANNEL_LINK'} eq '') {
		&ErrorPrint("uTCgURLv͂ĉB");
	} else {
		unless(&UrlCheck($in{'CHANNEL_LINK'})) {
			&ErrorPrint("uTCgURLvsK؂łBhttp:// LqĉB");
		}
		if($in{'CHANNEL_LINK'} =~ /^http\:\/\//i) {
			my($header, $res);
			FCC::Net::http::head($in{'CHANNEL_LINK'}, \$header, \$res);
			if($res) {
				&ErrorPrint("<p>TCgURLɎw肵URL͐܂B</p><p>$in{'CHANNEL_LINK'}</p><pre>${res}</pre>");
			}
		}
	}
	#쌠\L
	if($in{'CHANNEL_COPYRIGHT'} ne '') {
		$in{'CHANNEL_COPYRIGHT'} =~ s/\t//g;
		$in{'CHANNEL_COPYRIGHT'} =~ s/^\s+//;
		$in{'CHANNEL_COPYRIGHT'} =~ s/\s+$//;
		$in{'CHANNEL_COPYRIGHT'} =~ s/\n//g;
	}
	#TCg̐
	$in{'CHANNEL_DESCRIPTION'} = MIME::Base64::Perl::encode_base64($in{'CHANNEL_DESCRIPTION'}, '');
	#gD
	if($in{'CHANNEL_PUBLISHER'} ne '') {
		$in{'CHANNEL_PUBLISHER'} =~ s/\t//g;
		$in{'CHANNEL_PUBLISHER'} =~ s/^\s+//;
		$in{'CHANNEL_PUBLISHER'} =~ s/\s+$//;
		$in{'CHANNEL_PUBLISHER'} =~ s/\n//g;
	}
	#ҏW
	if($in{'CHANNEL_CREATOR'} ne '') {
		$in{'CHANNEL_CREATOR'} =~ s/\t//g;
		$in{'CHANNEL_CREATOR'} =~ s/^\s+//;
		$in{'CHANNEL_CREATOR'} =~ s/\s+$//;
		$in{'CHANNEL_CREATOR'} =~ s/\n//g;
	}
	#ҏW҃[AhX
	if($in{'CHANNEL_CREATOR_MAIL'} ne '') {
		$in{'CHANNEL_CREATOR_MAIL'} =~ s/\t//g;
		$in{'CHANNEL_CREATOR_MAIL'} =~ s/^\s+//;
		$in{'CHANNEL_CREATOR_MAIL'} =~ s/\s+$//;
		$in{'CHANNEL_CREATOR_MAIL'} =~ s/\n//g;
		unless(&MailAddressCheck($in{'CHANNEL_CREATOR_MAIL'})) {
			&ErrorPrint("uҏW҃[AhXvsK؂łB");
		}
	}
	#S\tO
	if($in{'IMAGE_FLAG'} eq '1') {
		if($in{'IMAGE_URL'} eq '') {
			&ErrorPrint("摜URLw肵ĉB");
		} else {
			unless(&UrlCheck($in{'IMAGE_URL'})) {
				&ErrorPrint("摜URLsK؂łB");
			}
			unless($in{'IMAGE_URL'} =~ /\.(gif|jpg|jpeg|png)$/i) {
				&ErrorPrint("S摜 GIF/JPEG/PNG ̂ꂩ̃tH[}bgłȂ΂܂B");
			}
		}
		if($in{'IMAGE_TITLE'} eq '') {
			&ErrorPrint("S摜̐w肵ĉB");
		}
		if($in{'IMAGE_LINK'} eq '') {
			&ErrorPrint("S摜̃NURLw肵ĉB");
		} else {
			unless(&UrlCheck($in{'IMAGE_LINK'})) {
				&ErrorPrint("S摜̃NURLsK؂łB");
			}
		}
	} elsif($in{'IMAGE_FLAG'} eq '') {
		$in{'IMAGE_URL'} = '';
		$in{'IMAGE_TITLE'} = '';
		$in{'IMAGE_LINK'} = '';
	} else {
		&ErrorPrint("sȒlM܂B\[IMAGE_FLAG\]");
	}
	#SC[W̃TCY`FbN
	if($in{'IMAGE_FLAG'} eq '1') {
		if($in{'IMAGE_URL'} =~ /^http\:\/\//i) {
			my($header, $res);
			my $image_data = FCC::Net::http::get($in{'IMAGE_URL'}, \$header, \$res);
			if($res) {
				&ErrorPrint("<p>S摜擾ł܂łBS摜URLmFĉB</p><p>$in{'IMAGE_URL'}</p><pre>${res}</pre>");
			}
			if($image_data) {
				my($x, $y, $id) = Image::Size::imgsize(\$image_data);
				unless($x && $y) {
					&ErrorPrint("w肳ꂽSC[ẂAF\ȉ摜ł͂܂B$id");
				}
				if($id !~ /^(GIF|JPG|PNG)$/i) {
					&ErrorPrint("SC[ẂAGIF/JPEG/PNG ̉摜tH[}bgłȂ΂܂B$id");
				}
				if($x > 144 || $y > 400) {
					&ErrorPrint("S摜̃TCÝA144 ~ 400 ȓłȂ΂܂B${x} ~ ${y}");
				}
			}
		}
	}
	#JeS[
	if($in{'CATEGORIES'} ne '') {
		my @lines = split(/\n/, $in{'CATEGORIES'});
		my @cates;
		for my $line (@lines) {
			$line =~ s/\t//g;
			$line =~ s/^\s+//;
			$line =~ s/\s+$//;
			if($line eq '') {next;}
			push(@cates, $line);
		}
		my $value = join("\t", @cates);
		$in{'CATEGORIES'} = $value;
	}


	#ݒ
	&WriteConf('./conf/channel.cgi', \%in);
}

sub MailAddressCheck {
    my($mail) = @_;
    #`FbN1isK؂ȕ`FbNj
    if($mail =~ /[^a-zA-Z0-9\@\.\-\_]/) {
        return 0;
    }
    #`FbN2i@}[Ñ`FbNj
    #"@"̐𐔂܂B1ȊOꍇɂ0Ԃ
    my $at_num = 0;
    while($mail =~ /\@/g) {
        $at_num ++;
    }
    if($at_num != 1) {
        return 0;
    }
    #`FbN3iAJEgAhC݂̑`FbNj
    my($acnt, $domain) = split(/\@/, $mail);
    if($acnt eq '' || $domain eq '') {
        return 0;
    }
    #`FbN4ihC̃hbg`FbNj
    #hbg̐𐔂܂B0ꍇɂ0Ԃ
    my $dot_num = 0;
    while($domain =~ /\./g) {
        $dot_num ++;
    }
    if($dot_num == 0) {
        return 0;
    }
    #`FbN5ihC̊ep[c`FbNj
    #擪ɃhbgȂƂ`FbN
    if($domain =~ /^\./) {
        return 0;
    }
    #ŌɃhbgȂƂ`FbN
    if($domain =~ /\.$/) {
        return 0;
    }
    #hbg2ȏ㑱ĂȂ`FbN
    if($domain =~ /\.\./) {
        return 0;
    }
    #`FbN6iTLD̃`FbNj
    my @domain_parts = split(/\./, $domain);
    my $tld = pop @domain_parts;
    if($tld =~ /[^a-zA-Z]/) {
        return 0;
    }
    #ׂẴ`FbNʂ̂ŁA
    #̃[AhX͓K؂ł
    return 1;
}

sub SetConf1 {
	#͒l擾B
	my %in = %CONF;
	$in{'FORMAT_RSS10'} = $q->param('FORMAT_RSS10');
	$in{'FORMAT_RSS20'} = $q->param('FORMAT_RSS20');
	$in{'FORMAT_ATOM'} = $q->param('FORMAT_ATOM');
	$in{'FILE_PATH_RSS10'} = $q->param('FILE_PATH_RSS10');
	$in{'FILE_PATH_RSS20'} = $q->param('FILE_PATH_RSS20');
	$in{'FILE_PATH_ATOM'} = $q->param('FILE_PATH_ATOM');
	$in{'RSS_PRINT_NUM'} = $q->param('RSS_PRINT_NUM');
	$in{'HTML_FLAG'} = $q->param('HTML_FLAG');
	$in{'HTML_PATH'} = $q->param('HTML_PATH');
	$in{'HTML_CHARSET'} = $q->param('HTML_CHARSET');
	$in{'HTML_PRINT_NUM'} = $q->param('HTML_PRINT_NUM');
	$in{'SAVED_NUM'} = $q->param('SAVED_NUM');
	$in{'TIMEZONE_OFFSET'} = $q->param('TIMEZONE_OFFSET');
	#sR[h𓝈ꂷ
	while( my($key, $value) = each %in ) {
		$value = &UnifyReturnCode($value);
		$in{$key} = $value;
	}
	#ꂼ̓͒l`FbN
	#RSS1.0
	if($in{'FORMAT_RSS10'} eq '1') {
		if($in{'FILE_PATH_RSS10'} eq '') {
			&ErrorPrint("RSS1.0̃t@Co͐w肵ĉB");
		} else {
			if($in{'FILE_PATH_RSS10'} =~ /[^a-zA-Z0-9\/\:\-\_\.\@\+\t\s]/) {
				&ErrorPrint("uRSS1.0̃t@Co͐vɕsK؂ȕ܂܂Ă܂B");
			}
			if(-e $in{'FILE_PATH_RSS10'}) {
				unless(-w $in{'FILE_PATH_RSS10'}) {
					&ErrorPrint("uRSS1.0̃t@Co͐vɎw肵t@Cłɑ݂Ă܂A܂B");
				}
			} else {
				if( open(FILE, ">$in{'FILE_PATH_RSS10'}") ) {
					close(FILE);
				} else {
					&ErrorPrint("RSS1.0̃t@C̏o͐փt@CނƂł܂B: $!");
				}
			}
		}
	} elsif($in{'FORMAT_RSS10'} ne '') {
		&ErrorPrint("sȒlM܂B[FORMAT_RSS10]");
	}
	#RSS2.0
	if($in{'FORMAT_RSS20'} eq '1') {
		if($in{'FILE_PATH_RSS20'} eq '') {
			&ErrorPrint("RSS2.0̃t@Co͐w肵ĉB");
		} else {
			if($in{'FILE_PATH_RSS20'} =~ /[^a-zA-Z0-9\/\:\-\_\.\@\+\t\s]/) {
				&ErrorPrint("uRSS2.0̃t@Co͐vɕsK؂ȕ܂܂Ă܂B");
			}
			if(-e $in{'FILE_PATH_RSS20'}) {
				unless(-w $in{'FILE_PATH_RSS20'}) {
					&ErrorPrint("uRSS2.0̃t@Co͐vɎw肵t@Cłɑ݂Ă܂A܂B");
				}
			} else {
				if( open(FILE, ">$in{'FILE_PATH_RSS20'}") ) {
					close(FILE);
				} else {
					&ErrorPrint("RSS2.0̃t@C̏o͐փt@CނƂł܂B: $!");
				}
			}
		}
	} elsif($in{'FORMAT_RSS20'} ne '') {
		&ErrorPrint("sȒlM܂B[FORMAT_RSS20]");
	}
	#ATOM
	if($in{'FORMAT_ATOM'} eq '1') {
		if($in{'FILE_PATH_ATOM'} eq '') {
			&ErrorPrint("atom̃t@Co͐w肵ĉB");
		} else {
			if($in{'FILE_PATH_ATOM'} =~ /[^a-zA-Z0-9\/\:\-\_\.\@\+\t\s]/) {
				&ErrorPrint("uatom̃t@Co͐vɕsK؂ȕ܂܂Ă܂B");
			}
			if(-e $in{'FILE_PATH_ATOM'}) {
				unless(-w $in{'FILE_PATH_ATOM'}) {
					&ErrorPrint("uatom̃t@Co͐vɎw肵t@Cłɑ݂Ă܂A܂B");
				}
			} else {
				if( open(FILE, ">$in{'FILE_PATH_ATOM'}") ) {
					close(FILE);
				} else {
					&ErrorPrint("atom̃t@C̏o͐փt@CނƂł܂B: $!");
				}
			}
		}
	} elsif($in{'FORMAT_ATOM'} ne '') {
		&ErrorPrint("sȒlM܂B[FORMAT_ATOM]");
	}
	#RSŜꂩIĂ邱Ƃ`FbN
	if($in{'FORMAT_RSS10'} eq '' && $in{'FORMAT_RSS20'} eq '' && $in{'FORMAT_ATOM'} eq '') {
		&ErrorPrint("RSStH[}bĝꂩIĉB");
	}
	#RSSo͋L
	if($in{'RSS_PRINT_NUM'} eq '') {
		&ErrorPrint("uRSSo͋Lvw肵ĉB");
	} else {
		if($in{'RSS_PRINT_NUM'} =~ /[^0-9]/) {
			&ErrorPrint("uRSSo͋Lv͔pŎw肵ĉB");
		} elsif($in{'RSS_PRINT_NUM'} eq '0') {
			&ErrorPrint("uRSSo͋Lvɂ0w肷邱Ƃ͂ł܂B");
		}
	}
	#gbvy[WpHTML
	if($in{'HTML_FLAG'} eq '1') {
		if($in{'HTML_PATH'} eq '') {
			&ErrorPrint("uHTMLo͐vw肵ĉB");
		} else {
			if($in{'HTML_PATH'} =~ /[^a-zA-Z0-9\/\:\-\_\.\@\+\t\s]/) {
				&ErrorPrint("uHTMLo͐vɕsK؂ȕ܂܂Ă܂B");
			}
			if(-e $in{'HTML_PATH'}) {
				unless(-w $in{'HTML_PATH'}) {
					&ErrorPrint("uHTMLo͐vɎw肵t@Cłɑ݂Ă܂A܂B");
				}
			} else {
				if( open(FILE, ">$in{'HTML_PATH'}") ) {
					close(FILE);
				} else {
					&ErrorPrint("uHTMLo͐vփt@CނƂł܂B: $!");
				}
			}
		}
		if($in{'HTML_CHARSET'} eq '') {
			&ErrorPrint("uCharset iR[hjvw肵ĉB");
		} else {
			if($in{'HTML_CHARSET'} !~ /^(1|2|3)$/) {
				&ErrorPrint("uCharset iR[hjvɕsȒlM܂B");
			}
		}
		#gbvy[W\L
		if($in{'HTML_PRINT_NUM'} eq '') {
			&ErrorPrint("ugbvy[W\Lvw肵ĉB");
		} else {
			if($in{'HTML_PRINT_NUM'} =~ /[^0-9]/) {
				&ErrorPrint("ugbvy[W\Lv͔pŎw肵ĉB");
			} elsif($in{'HTML_PRINT_NUM'} eq '0') {
				&ErrorPrint("ugbvy[W\Lvɂ0w肷邱Ƃ͂ł܂B");
			}
		}
	} elsif($in{'HTML_FLAG'} ne '') {
		&ErrorPrint("sȒlM܂B[HTML_PATH]");
	} else {
		$in{'HTML_PATH'} = '';
		$in{'HTML_PRINT_NUM'} = '';
		$in{'HTML_CHARSET'} = '';
	}

	#f[^ۑL
	if($in{'SAVED_NUM'} eq '') {
		&ErrorPrint("uf[^ۑLvw肵ĉB");
	} else {
		if($in{'SAVED_NUM'} =~ /[^0-9]/) {
			&ErrorPrint("uf[^ۑLv͔pŎw肵ĉB");
		} elsif($in{'SAVED_NUM'} eq '0') {
			&ErrorPrint("uf[^ۑLvɂ0w肷邱Ƃ͂ł܂B");
		} else {
			if($in{'HTML_PRINT_NUM'} > 0) {
				if($in{'SAVED_NUM'} < $in{'HTML_PRINT_NUM'}) {
					&ErrorPrint("uf[^ۑLv́AuRSS\Lvugbvy[W\Lv傫lw肵ĉB");
				}
			}
			if($in{'RSS_PRINT_NUM'} > 0) {
				if($in{'SAVED_NUM'} < $in{'RSS_PRINT_NUM'}) {
					&ErrorPrint("uf[^ۑLv́AuRSS\Lvugbvy[W\Lv傫lw肵ĉB");
				}
			}
		}
	}
	#^C][ItZbg
	if($in{'TIMEZONE_OFFSET'} eq '') {
		&ErrorPrint("^C][ItZbgw肵ĉB");
	} else {
		if($in{'TIMEZONE_OFFSET'} =~ /^(\+|\-){0,1}([0-9]{1,2})$/) {
			my $sign = $1;
			my $offset = $2;
			if($sign eq '+') {
				$in{'TIMEZONE_OFFSET'} = $2;
			}
			if($offset > 12) {
				&ErrorPrint("^C][ItZbg̎w肪ԈĂ܂B");
			}
		} else {
			&ErrorPrint("^C][ItZbg̎w肪ԈĂ܂B");
		}
	}
	#ݒ
	&WriteConf('./conf/config.cgi', \%in);
}

sub PrintConf1Form {
	my $html = &ReadTemplate("./template/admin/conf1.html");
	while( my($key, $value) = each %CONF) {
		$value = &SecureHtml($value);
		if($key =~ /^(FORMAT_RSS10|FORMAT_RSS20|FORMAT_ATOM|HTML_FLAG)$/) {
			if($CONF{$key}) {
				$html =~ s/\s*\$${key}\$/ checked/;
			} else {
				$html =~ s/\s*\$${key}\$//g;
			}
		} elsif($key eq 'HTML_CHARSET') {
			$html =~ s/\$HTML_CHARSET${value}\$/selected/;
			$html =~ s/\$HTML_CHARSET\d+\$//;
		} else {
			$html =~ s/\$${key}\$/${value}/g;
		}
	}
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintConf2Form {
	my $html = &ReadTemplate("./template/admin/conf2.html");
	while( my($key, $value) = each %CONF2) {
		$value = &SecureHtml($value);
		if($key eq 'CATEGORIES') {
			$value =~ s/\t/\n/g;
		} elsif($key eq 'CHANNEL_DESCRIPTION') {
			$value = MIME::Base64::Perl::decode_base64($value);
		} elsif($key eq 'IMAGE_FLAG') {
			if($value eq '1') {
				$value = 'checked';
			} else {
				$value = '';
			}
		}
		$html =~ s/\$${key}\$/${value}/g;
	}
	if($CONF2{'IMAGE_FLAG'}) {
		$html =~ s/\$IMAGE\$/<a href=\"$CONF2{'IMAGE_LINK'}\" target=\"_blank\"><img src=\"$CONF2{'IMAGE_URL'}\" border=\"0\" alt=\"$CONF2{'IMAGE_TITLE'}\"><\/a>/g;
	} else {
		$html =~ s/\$IMAGE\$//g;
	}

	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintHelp {
	my $item = $q->param('item');
	if($item =~ /[^a-zA-Z0-9\_\-]/) {
		&ErrorPrint("sȃNGXgłB");
	}
	if($item eq '') {
		&ErrorPrint("sȃNGXgłB");
	}
	my $file = "./lib/help/${item}.html";
	my $html = &ReadTemplate($file);
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintComplete {
	my($message, $link_cap, $link_url) = @_;
	my $template = './template/admin/complete.html';
	my $html = &ReadTemplate($template);
	$html =~ s/\$MESSAGE\$/${message}/g;
	if($link_url) {
		$html =~ s/\$LINK\$/<a href=\"${link_url}\">${link_cap}<\/a>/g;
	} else {
		$html =~ s/\$LINK\$//g;
	}
	my $content_length = length($html);
	#print "Cache-Control: no-cache\n";
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub LogOff {
	my($sid) = @_;
	my $session = new FCC::Apache::Session("./session");
	$session->logoff($sid);
	my $message = 'OIt܂B';
	my $link_cap = 'OIʂ';
	my $template = './template/admin/complete.html';
	my $html = &ReadTemplate($template);
	$html =~ s/\$MESSAGE\$/${message}/g;
	$html =~ s/\$LINK\$/<a href=\"${CGI_URL}\">${link_cap}<\/a>/g;
	my $content_length = length($html);
	print &ClearCookie($COOKIE_NAME);
	print "Content-Length: $content_length\n";
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "\n";
	print $html;
	exit;
}

sub PrintLogonForm {
	#ev[gǂݍ
	my $template = './template/admin/logon.html';
	my $html = &ReadTemplate($template);
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub SessionAuth {
	my($sid, $session_data_ref) = @_;
	my $session = new FCC::Apache::Session("./session");
	%{$session_data_ref} = $session->sessoin_auth($sid);
	unless($session_data_ref->{_sid}) {
		my $err = "F؂Ɏs܂B<br>\n" . $session->error();
		print &ClearCookie($COOKIE_NAME);
		print "Content-Type: text/plain\n";
		print "\n";
		print "$err";
		exit;
	}
	return $session;
}

sub LogOn {
	my $in_id = $q->param('id');
	my $in_pass = $q->param('pass');
	if($in_id eq '') {
		&ErrorPrint("ǗID͂ĉB");
	}
	if($in_pass eq '') {
		&ErrorPrint("pX[h͂ĉB");
	}
	if($CONF{'ADMIN_ID'} ne $in_id) {
		&ErrorPrint("F؃G[");
	}
	my $in_pass_digest = Digest::Perl::MD5::md5_hex($in_pass);
	if($in_pass_digest ne $CONF{'PASS'}) {
		&ErrorPrint("F؃G[");
	}
	my $session = new FCC::Apache::Session("./session");
	unless($session) {
		&ErrorPrint("VXeG[");
	}
	my %session_data = ${session}->session_create($in_id);
	unless($session_data{_sid}) {
		my $err = "F؂Ɏs܂B<br>\n" . $session->error();
		&PrintError("$err");
	}
	my $target_url = $CGI_URL . "?t=" . time;
	print &SetCookie($COOKIE_NAME, $session_data{_sid});
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "\n";
	print "<html>\n";
	print "<head>\n";
	print "<meta http-equiv=\"content-type\" content=\"text/html;charset=shift_jis\">\n";
	print "<meta http-equiv=\"Set-Cookie\" content=\"${COOKIE_NAME}=$session_data{_sid};\">\n";
	print "<meta http-equiv=\"refresh\" content=\"0;URL=${target_url}\">\n";
	print "<title>OI...</title>\n";
	print "</head>\n";
	print "<body>\n";
	print "<p>OI ...</p>\n";
	print "</body></html>\n";
	exit;
}

sub PrintPasswdSetForm {
	#ev[gǂݍ
	my $template = './template/admin/passwd_new.html';
	my $html = &ReadTemplate($template);
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintPasswdChangeComplete {
	my $html = &ReadTemplate('./template/admin/complete.html');
	my $message = 'ǗID^pX[hύX܂BłɃOIt܂̂ŁAVID^pX[hŃOIĉB';
	$html =~ s/\$MESSAGE\$/${message}/;
	$html =~ s/\$LINK\$/<a href=\"${CGI_URL}\" target=\"_top\">OI<\/a>/;
	my $content_length = length $html;
	print &ClearCookie($COOKIE_NAME);
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PasswdChange {
	my $admin_id = $q->param('ADMIN_ID');
	my $pass1 = $q->param('PASS1');
	my $pass2 = $q->param('PASS2');
	if($admin_id eq '') {
		&ErrorPrint("ǗID͂ĉB");
	} else {
		if($admin_id =~ /[^0-9a-zA-Z\-\_]/) {
			&ErrorPrint("ǗIDɎwł镶͔ppAnCtAA_[XRAłB");
		}
	}
	if($pass1 eq '' || $pass2 eq '') {
		&ErrorPrint("pX[h͂ĉB");
	}
	if($pass1 =~ /[^0-9a-zA-Z\-\_]/) {
		&ErrorPrint("pX[hɎwł镶͔ppAnCtAA_[XRAłB");
	}
	if($pass1 ne $pass2) {
		&ErrorPrint("pX[hႢ܂B");
	}
	$CONF{'ADMIN_ID'} = $admin_id;
	$CONF{'PASS'} = Digest::Perl::MD5::md5_hex($pass1);
	&WriteConf('./conf/config.cgi', \%CONF);
}

sub PrintPasswdForm {
	my $html = &ReadTemplate('./template/admin/passwd_change.html');
	$html =~ s/\$ADMIN_ID\$/$CONF{'ADMIN_ID'}/;
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub WriteConf {
	my($file, $data_ref) = @_;
	open(FILE, ">${file}") or &ErrorPrint("ݒt@C݂̏Ɏs܂B: $!");
	while( my($key, $value) = each %{$data_ref} ) {
		$value = &UnifyReturnCode($value);
		print FILE "${key}\t${value}\n";
	}
	close(FILE);
}

sub PrintTopFrame {
	my $html = &ReadTemplate("./template/admin/top.html");
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintMenuFrame {
	my $html = &ReadTemplate("./template/admin/menu.html");
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintParentFrame {
	my $html = &ReadTemplate("./template/admin/parent.html");
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub GetConf {
	my($file) = @_;
	my %data;
	open(FILE, "$file") || &ErrorPrint("ݒt@C $file I[vł܂łB: $!");
	while(my $line = <FILE>) {
		chomp $line;
		if($line =~ /^([^\t]+)\t(.*)/) {
			$data{$1} = $2;
		}
	}
	close(FILE);
	return %data;
}


sub UnifyReturnCode {
	my($String) = @_;
	$String =~ s/\x0D\x0A/\n/g;
	$String =~ s/\x0D/\n/g;
	$String =~ s/\x0A/\n/g;
	return $String;
}

sub GetCookie {
    #Cookie=CookielzɊi[B
    my @pairs = split(/\;\s*/, $ENV{'HTTP_COOKIE'});
    #Cookiei[Azz%cookies`B
    my %cookies;
    for my $pair (@pairs) {
        #Cookie=Cookiel = ŕāAXJ[ϐɊi[B
        my($name, $value) = split(/=/, $pair);
        #CookielURLfR[hB
        $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
        $value =~ s/\+/ /g;
        #Azz%cookiesɊi[B
        $cookies{$name} = $value;
    }
    #Cookiei[Azz%cookiesԂB
    return %cookies;
}

sub SetCookie {
    my($name, $value, $expire, $domain, $path) = @_;
    #Cookie̒lURLGR[hB
    $value =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
    $value =~ tr/ /+/;
    #Cookiewb_[`B
    #ł́ACookieCookielZbgB
    my $header .= "Set-Cookie: $name=$value\;";
    #L̎w肪΁AexpireCookiewb_[ɒǉB
    if($expire) {
        #LƂȂGMTŎ擾B
        my($sec, $min, $hour, $day, $mon, $year, $weekday) = 
          gmtime(time + $expire*60*60*24);
        #N𐼗ɂB
        $year += 1900;
        #bAAԁA10菬l̏ꍇA擪0B
        $sec = sprintf("%02d", $sec);
        $min = sprintf("%02d", $min);
        $hour = sprintf("%02d", $hour);
        $day = sprintf("%02d", $day);
        #zɒ`B
        my @month_list = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
                    'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
        #jzɒ`B
        my @week_list = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
        #L𐶐B
        #j͗jɁA͌ɕϊB
        my $date = "$week_list[$weekday], $day-$month_list[$mon]-$year $hour:$min:$sec GMT";
        #Cookiewb_[ɗLǉB
         $header .= " expires=$date;";
    }
    #hC̎w肪΁AdomainCookiewb_[ɒǉB
    if($domain) {
        $header .= " domain=$domain;";
    }
    #pX̎w肪΁ApathCookiewb_[ɒǉB
    if($path) {
        $header .= " path=$path;";
    }
    #Set-Cookiewb_[̍ŌɉsB
    $header .= "\n";
    #Set-Cookiewb_[ԂB
    return $header;
}

sub ClearCookie {
    my($name) = @_;
    #CookieL 1970/1/1 00:00:00 ɃZbgB
    my $expire = 'Thu, 01-Jan-1970 00:00:00 GMT';
    #Set-Cookiewb_[𐶐B
    #Cookiel͉łǂ̂ŁAł clear ƂB
    my $cookie_header = "Set-Cookie: $name=clear; expires=$expire;";
    #Set-Cookiewb_[̍ŌɉsB
    $cookie_header .= "\n";
    #Set-Cookiewb_[ԂB
    return $cookie_header;
}

sub SecureHtml {
	my($html) = @_;
	$html =~ s/\&amp;/\&/g;
	$html =~ s/\&/&amp;/g;
	$html =~ s/\"/&quot;/g;
	$html =~ s/</&lt;/g;
	$html =~ s/>/&gt;/g;
	return $html;
}

sub UrlCheck {
	my($url) = @_;
	unless($url =~ /^https*:\/\/[^\/]+/) {
		return;
	}
	if($url =~ /[^0-9a-zA-Z\:\/\.\-\_\#\%\&\=\~\+\?]/) {
		return;
	}
	return 1;
}

sub ReadTextFile {
	my($file) = @_;
	my $size = -s $file;
	if(!open(IN, "$file")) {
		&ErrorPrint2("$file I[vł܂łB : $!");
	}
	binmode(IN);
	my $string;
	sysread(IN, $string, $size);
	close(IN);
	$string = &UnifyReturnCode($string);
	return $string;
}

sub ReadTemplate {
	my($template) = @_;
	my $size = -s $template;
	if(!open(IN, "$template")) {
		&ErrorPrint2("ev[gt@C $template I[vł܂łB : $!");
	}
	binmode(IN);
	my $filestr;
	sysread(IN, $filestr, $size);
	close(IN);
	$filestr = &UnifyReturnCode($filestr);
	$filestr = &CopyRight($filestr);
	$filestr =~ s/\$CGI_URL\$/${CGI_URL}/g;
	return $filestr;
}

sub CopyRight {
	my($str) = @_;
	$str =~ s/\$COPYRIGHT\$/${COPYRIGHT}/g;
	$str =~ s/\$COPYRIGHT1\$/${COPYRIGHT1}/g;
	$str =~ s/\$COPYRIGHT2\$/${COPYRIGHT2}/g;
	$str =~ s/\$TITLE\$/${COPYRIGHT}/g;
	return $str;
}

sub ErrorPrint {
	my($message) = @_;
	my $html = &ReadTemplate("./template/admin/error.html");
	$html =~ s/\$error\$/$message/ig;
	$html = &CopyRight($html);
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub ErrorPrint2 {
	my($message) = @_;
	print "Content-Type: text/plain; charset=Shift_JIS\n";
	print "\n";
	print $message;
	exit;
}

sub GetThisFileName {
	my $string;
	if($ENV{'SCRIPT_NAME'}) {
		$string = $ENV{'SCRIPT_NAME'};
	} elsif($ENV{'REQUEST_URI'}) {
		$string = $ENV{'REQUEST_URI'};
	} else {
		return 'admin.cgi';
	}
	my($part) = split(/\?/, $string);
	my @parts = split(/\//, $part);
	my $script_name = pop @parts;
	return $script_name;
}

sub TruncateSjisString {
	my($string, $len) = @_;
	my @chars = &SpritSjisChars($string);
	my $new_string;
	my $len_tmp = 0;
	for my $char (@chars) {
		if($len_tmp + length($char) <= $len) {
			$new_string .= $char;
			$len_tmp += length($char);
		} else {
			last;
		}
	}
	return $new_string;
}

sub SpritSjisChars {
	my($string) = @_;
	$_ = $string;
	my @chars = /
		 [\x20-\x7E]             #ASCII
		|[\xA1-\xDF]             #pJ^Ji
		|[\x81-\x9F][\x40-\xFC]  #2oCg
		|[\xE0-\xEF][\x40-\xFC]  #2oCg
	/gox;
	return @chars;
}
