package FCC::Net::http;
use strict;
use Socket;

my $timeout = 10;

sub head {
	my($url, $header_ref, $res_ref) = @_;
	#URL𕪉
	my @url_parts = &parse_url($url);
	#擪 http ̃vgRw肳ĂȂ
	#_errorɗRZbgāAundefԂ
	if(!defined $url_parts[0]) {
		$$res_ref = "w肳ꂽURLsK؂łB";
		return;
	}
	#URLhttpȊOw肳ĂA
	#_errorɗRZbgāAundefԂB
	unless($url_parts[0] =~ /^http$/i) {
		$$res_ref = "w肳ꂽURLsK؂łB";
		return;
	}
	#T[oɐڑiTCPI[vj
	#sA_errorɗRZbgāAundefԂ
	if(my $err = &open_tcp(*F, $url_parts[1], $url_parts[2])) {
		$$res_ref = $err;
		return;
	}
	#HTTPNGXg𑗐M
	print F "HEAD $url_parts[3] HTTP/1.1\n";
	print F "Host: $url_parts[1]:$url_parts[2]\n";
	print F "User-Agent: futomi_browser/1.0\n";
	print F "Accept: */*\n";
	print F "\n";
	#^CAEg
	my $response;
	my $body;
	eval {
		local $SIG{ALRM} = sub {die "timeout"};
		alarm $timeout;
		my $header;
		#HTTPX|Xs擾
		$response = <F>;
		$header .= $response;
		my($proto, $code, $status) = $response =~ /^(\S+)\s+(\S+)\s+(.*)$/;
		#X|XR[h200ijłȂ΃G[ԂB
		if($code ne '200') {
			close(F);
			die "$response";
		}
		#wb_[擾
		while(my $line = <F>) {
			if($line !~ /^([^\:]+):\s+(.+)/) {
				last;
			}
			$header .= $line;
		}
		$$header_ref = $header;
		#lbg[N
		close(F);
		alarm 0;
	};
	alarm 0;
	if($@) {
		$$res_ref = $@;
		return;
	}
}

sub get {
	my($url, $header_ref, $res_ref) = @_;
	#URL𕪉
	my @url_parts = &parse_url($url);
	#擪 http ̃vgRw肳ĂȂ
	#_errorɗRZbgāAundefԂ
	if(!defined $url_parts[0]) {
		$$res_ref = "w肳ꂽURLsK؂łB";
		return;
	}
	#URLhttpȊOw肳ĂA
	#_errorɗRZbgāAundefԂB
	unless($url_parts[0] =~ /^http$/i) {
		$$res_ref = "w肳ꂽURLsK؂łB";
		return;
	}
	#T[oɐڑiTCPI[vj
	#sA_errorɗRZbgāAundefԂ
	if(my $err = &open_tcp(*F, $url_parts[1], $url_parts[2])) {
		$$res_ref = $err;
		return;
	}
	#HTTPNGXg𑗐M
	print F "GET $url_parts[3] HTTP/1.1\n";
	print F "Host: $url_parts[1]:$url_parts[2]\n";
	print F "User-Agent: futomi_browser/1.0\n";
	print F "Accept: */*\n";
	print F "\n";
	#^CAEg
	my $response;
	my $body;
	eval {
		local $SIG{ALRM} = sub {die "timeout"};
		alarm $timeout;
		my $header;
		#HTTPX|Xs擾
		$response = <F>;
		$header .= $response;
		my($proto, $code, $status) = $response =~ /^(\S+)\s+(\S+)\s+(.*)$/;
		#X|XR[h200ijłȂ΃G[ԂB
		if($code ne '200') {
			close(F);
			die "$response";
		}
		#wb_[擾
		my($content_length, $transfer_encoding);
		while(my $line = <F>) {
			if($line !~ /^(\S+):\s+(.+)/) {
				last;
			}
			my $key = $1;
			my $value = $2;
			if($key =~ /Content\-Length/i) {
				$content_length = $value;
			} elsif($key =~ /transfer\-encoding/i) {
				$transfer_encoding = $value;
			}
			$header .= "${key}: ${value}\n";
		}
		$$header_ref = $header;
		my $chunked = 0;
		if($transfer_encoding =~ /chunked/i) {
			$chunked = 1;
		}
		#{fB[擾
		my $len = 0;
		if($chunked) {
			my $pos = 0;
			my $chunk_size = 0;
			my $len = 0;
			while(my $line = <F>) {
				if($pos) {
					$body .= $line;
					$len += length($line);
					if($len >= $chunk_size) {
						$pos = 0;
						$len = 0;
						$chunk_size = 0;
						chomp $body;
						$body =~ s/\r$//;
					}
				} else {
					chomp $line;
					$line =~ s/\r$//;
					if($line eq '') {next;}
					$chunk_size = hex($line);
					if($chunk_size == 0) {
						last;
					}
					$pos = 1;
				}
			}
		} else {
			read(F, $body, $content_length);
		}
		#lbg[N
		close(F);
		alarm 0;
	};
	alarm 0;
	if($@) {
		$$res_ref = $@;
		return;
	}
	return $body;
}

sub post {
	my($url, $content_type, $data, $header_ref, $res_ref) = @_;
	#URL𕪉
	my @url_parts = &parse_url($url);
	#擪 http ̃vgRw肳ĂȂ
	#_errorɗRZbgāAundefԂ
	if(!defined $url_parts[0]) {
		$$res_ref = "w肳ꂽURLsK؂łB";
		return;
	}
	#URLhttpȊOw肳ĂA
	#_errorɗRZbgāAundefԂB
	unless($url_parts[0] =~ /^http$/i) {
		$$res_ref = "w肳ꂽURLsK؂łB";
		return;
	}
	#T[oɐڑiTCPI[vj
	#sA_errorɗRZbgāAundefԂ
	if(my $err = &open_tcp(*F, $url_parts[1], $url_parts[2])) {
		$$res_ref = $err;
		return;
	}
	#HTTPNGXg𑗐M
	print F "POST $url_parts[3] HTTP/1.1\n";
	print F "Host: $url_parts[1]:$url_parts[2]\n";
	print F "User-Agent: futomi_browser/1.0\n";
	print F "Accept: */*\n";
	if($data) {
		#postf[^̃TCYvZB
		my $data_len = length $data;
		if($content_type) {
			print F "Content-Type: ${content_type}\n";
		}
		print F "Content-length: ${data_len}\n";
		print F "\n";
		print F $data;
	}
	print F "\n";

	#^CAEg
	my $response;
	my $body;
	eval {
		local $SIG{ALRM} = sub {die "timeout"};
		alarm $timeout;
		my $header;
		#HTTPX|Xs擾
		$response = <F>;
		$header .= $response;
		my($proto, $code, $status) = $response =~ /^(\S+)\s+(\S+)\s+(.*)$/;
		#X|XR[h200ijłȂ΃G[ԂB
		if($code ne '200') {
			close(F);
			die "$response";
		}
		#wb_[擾
		my($content_length, $transfer_encoding);
		while(my $line = <F>) {
			if($line !~ /^(\S+):\s+(.+)/) {
				last;
			}
			my $key = $1;
			my $value = $2;
			if($key =~ /Content\-Length/i) {
				$content_length = $value;
			} elsif($key =~ /transfer\-encoding/i) {
				$transfer_encoding = $value;
			}
			$header .= "${key}: ${value}\n";
		}
		$$header_ref = $header;
		my $chunked = 0;
		if($transfer_encoding =~ /chunked/i) {
			$chunked = 1;
		}
		#{fB[擾
		my $len = 0;
		if($chunked) {
			my $pos = 0;
			my $chunk_size = 0;
			my $len = 0;
			while(my $line = <F>) {
				if($pos) {
					$body .= $line;
					$len += length($line);
					if($len >= $chunk_size) {
						$pos = 0;
						$len = 0;
						$chunk_size = 0;
						chomp $body;
						$body =~ s/\r$//;
					}
				} else {
					chomp $line;
					$line =~ s/\r$//;
					if($line eq '') {next;}
					$chunk_size = hex($line);
					if($chunk_size == 0) {
						last;
					}
					$pos = 1;
				}
			}
		} else {
			read(F, $body, $content_length);
		}
		#lbg[N
		close(F);
		alarm 0;
	};
	alarm 0;
	if($@) {
		$$res_ref = $@;
		return;
	}
	return $body;
}

#T[oTCPڑ
#sƁAG[eԂAundefԂB
sub open_tcp {
	my($FS, $dest, $port) = @_;
	my $proto = getprotobyname('tcp');
	socket($FS, PF_INET, SOCK_STREAM, $proto) || return "Can't make socket : $!";
	my $packed_addr = inet_aton($dest);
	unless($packed_addr) {return "Can't resolve host name";}
	my $sin = sockaddr_in($port, $packed_addr);
	connect($FS, $sin) || return "No response from server : $!";
	my $old_fh = select($FS);
	$| = 1;
	select $old_fh;
	return undef;
}

sub parse_url {
	my($url) = @_;
	(my @parsed = $url =~ m|(\w+)://([^/:]+)(:\d*)?([^#]*)|) || return undef;
	if(defined $parsed[2]) {
		$parsed[2] =~ s/^://;
	}
	$parsed[3] = '/' if($parsed[0] =~ /http/i && (length $parsed[3]) == 0);
	return @parsed if(defined $parsed[2]);
	$parsed[2] = 80;
	return @parsed;
}

1;
